package kaysaar.aotd_question_of_loyalty.data.plugins;

import java.util.Iterator;
import com.fs.starfarer.api.campaign.listeners.ListenerManagerAPI;
import kaysaar.aotd_question_of_loyalty.data.scripts.trackers.AoTDIncomeFixerTracker;
import kaysaar.aotd_question_of_loyalty.data.scripts.trackers.MagicLibBountyTracker;
import kaysaar.aotd_question_of_loyalty.data.intel.AoTDCommIntelPlugin;
import kaysaar.aotd_question_of_loyalty.data.intel.secession.AoTDNexInvasionListener;
import kaysaar.aotd_question_of_loyalty.data.scripts.trackers.AoTDHubMissionTracker;
import kaysaar.aotd_question_of_loyalty.data.scripts.effectapplier.AoTDIgnoreTurningOffTransponder;
import com.fs.starfarer.api.campaign.CampaignEventListener;
import kaysaar.aotd_question_of_loyalty.data.listeners.AoTDDestructionOfEnemiesTracker;
import kaysaar.aotd_question_of_loyalty.data.scripts.rulesInterceptor.BlockCommisionHostileActions;
import kaysaar.aotd_question_of_loyalty.data.scripts.effectapplier.AoTDSharedSensorLink;
import kaysaar.aotd_question_of_loyalty.data.scripts.AoTDDealWithNex;
import kaysaar.aotd_question_of_loyalty.data.scripts.trackers.DeliveryTracker;
import kaysaar.aotd_question_of_loyalty.data.scripts.trackers.ExplorationTracker;
import kaysaar.aotd_question_of_loyalty.data.scripts.trackers.BountyTracker;
import kaysaar.aotd_question_of_loyalty.data.scripts.rulesInterceptor.TalkWayFromScanScript;
import kaysaar.aotd_question_of_loyalty.data.scripts.rulesInterceptor.ResignCommsionReplaceScript;
import kaysaar.aotd_question_of_loyalty.data.scripts.rulesInterceptor.CommisionReplaceScript;
import com.fs.starfarer.api.EveryFrameScript;
import kaysaar.aotd_question_of_loyalty.data.scripts.rulesInterceptor.AICoreReplaceScript;
import kaysaar.aotd_question_of_loyalty.data.intel.secession.EmergentAuthorityApplier;
import kaysaar.aotd_question_of_loyalty.data.listeners.AoTDColonyCrisisInserter;
import kaysaar.aotd_question_of_loyalty.data.listeners.AoTDTransactionListener;
import kaysaar.aotd_question_of_loyalty.data.listeners.AoTDFreeStorageComm;
import com.fs.starfarer.api.Global;
import kaysaar.aotd_question_of_loyalty.data.scripts.commision.AoTDCommissionDataManager;
import com.fs.starfarer.api.BaseModPlugin;

public class AotDQoLPlugin extends BaseModPlugin
{
    public void onApplicationLoad() throws Exception {
        super.onApplicationLoad();
        AoTDCommissionDataManager.getInstance();
    }
    
    public void onGameLoad(final boolean newGame) {
        super.onGameLoad(newGame);
        final ListenerManagerAPI listener = Global.getSector().getListenerManager();
        listener.addListener((Object)new AoTDFreeStorageComm(), true);
        listener.addListener((Object)new AoTDTransactionListener(), true);
        listener.addListener((Object)new AoTDColonyCrisisInserter(), true);
        listener.addListener((Object)new EmergentAuthorityApplier(), true);
        Global.getSector().addTransientScript((EveryFrameScript)new AICoreReplaceScript());
        Global.getSector().addTransientScript((EveryFrameScript)new CommisionReplaceScript());
        Global.getSector().addTransientScript((EveryFrameScript)new ResignCommsionReplaceScript());
        Global.getSector().addTransientScript((EveryFrameScript)new TalkWayFromScanScript());
        Global.getSector().addTransientScript((EveryFrameScript)new BountyTracker());
        Global.getSector().addTransientScript((EveryFrameScript)new ExplorationTracker());
        Global.getSector().addTransientScript((EveryFrameScript)new DeliveryTracker());
        Global.getSector().addTransientScript((EveryFrameScript)new AoTDDealWithNex());
        Global.getSector().addTransientScript((EveryFrameScript)new AoTDSharedSensorLink());
        Global.getSector().addTransientScript((EveryFrameScript)new BlockCommisionHostileActions());
        Global.getSector().addTransientListener((CampaignEventListener)new AoTDDestructionOfEnemiesTracker());
        Global.getSector().addTransientScript((EveryFrameScript)new AoTDIgnoreTurningOffTransponder());
        Global.getSector().addTransientScript((EveryFrameScript)new AoTDHubMissionTracker());
        final Iterator<EveryFrameScript> iter = Global.getSector().getScripts().iterator();
        if (Global.getSettings().getModManager().isModEnabled("nexerlin")) {
            Global.getSector().getListenerManager().addListener((Object)new AoTDNexInvasionListener(), true);
        }
        while (iter.hasNext()) {
            final EveryFrameScript next = iter.next();
            if (next instanceof AoTDCommIntelPlugin) {
                if (AoTDCommIntelPlugin.get() != null && next.equals(AoTDCommIntelPlugin.get())) {
                    continue;
                }
                iter.remove();
            }
        }
        if (Global.getSettings().getModManager().isModEnabled("MagicLib")) {
            Global.getSector().addTransientScript((EveryFrameScript)new MagicLibBountyTracker());
        }
        Global.getSector().addTransientScript((EveryFrameScript)new AoTDIncomeFixerTracker());
        if (AoTDCommIntelPlugin.get() != null) {
            AoTDCommIntelPlugin.get().updateData();
        }
    }
}
